<link rel="import" href="chrome://resources/polymer/v1_0/polymer/polymer.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-flex-layout/classes/iron-flex-layout.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-icons/iron-icons.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-checkbox/paper-checkbox.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-icon-button/paper-icon-button.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/cr_collapse/cr_collapse.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/cr_expand_button/cr_expand_button.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/network/cr_network_icon.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/network/cr_onc_types.html">
<link rel="import" href="network_apnlist.html">
<link rel="import" href="network_ip_config.html">
<link rel="import" href="network_nameservers.html">
<link rel="import" href="network_property_list.html">
<link rel="import" href="network_proxy.html">
<link rel="import" href="network_siminfo.html">

<dom-module id="cr-settings-internet-detail-page">
  <link rel="import" type="css" href="chrome://md-settings/settings_page/settings_page.css">
  <link rel="import" type="css" href="internet_detail_page.css">
  <template>
    <div class="layout vertical">
      <!-- Title section: Icon + name + connection state. -->
      <div id="titleDiv" class="layout horizontal center">
        <cr-network-icon id="networkIcon" network-state="[[networkState]]">
        </cr-network-icon>
        <span id="networkName">[[getStateName_(networkState)]]</span>
        <span id="networkState"
            connected$="[[isConnectedState_(networkState)]]"
            >[[getStateText_(networkState)]]</span>
      </div>

      <div id="outerDiv" class="layout vertical">
        <!-- For Cellular, show SIM info first. -->
        <div id="simInfoDiv" class="layout vertical">
          <network-siminfo editable
              hidden$="[[!showCellularSim_(networkState)]]"
              network-state="[[networkState]]"
              on-siminfo-change="onNetworkPropertyChange_">
          </network-siminfo>
        </div>

        <!-- Info and properties common to all networks. -->
        <div id="infoDiv" class="layout vertical">
          <div class="layout horizontal" hidden$="[[!IPAddress]]">
            <span>IP Address:</span>
            <span>[[IPAddress]]</span>
          </div>
          <span hidden$="[[!showShared_(networkState)]]">
            This network is shared with other users.
          </span>
          <div class="layout horizontal center"
              hidden$="[[!showPreferNetwork_(networkState)]]">
            <paper-icon-button id="preferButton"
                toggles active="{{preferNetwork}}"
                icon="[[getPreferredIcon_(preferNetwork)]]">
            </paper-icon-button>
            <span>Prefer this network</span>
          </div>
          <paper-checkbox checked="{{autoConnect}}"
              hidden$="[[!showAutoConnect_(networkState)]]">
            Automatically connect to this network
          </paper-checkbox>

          <!-- Properties to always show if present. -->
          <network-property-list
              fields="[[getInfoFields_(networkState)]]"
              network-state="[[networkState]]">
          </network-property-list>
        </div>

        <!-- Button row: Advanced + Disconnect | Connect. -->
        <div class="layout horizontal center">
          <cr-button toggles active="{{advancedExpanded}}"
              hidden$="[[!hasAdvancedOrDeviceFields_(networkState)]]">
            Advanced
          </cr-button>
          <span class="flex"></span>
          <cr-button hidden$="[[!showViewAccount_(networkState)]]"
              on-click="onViewAccountClicked_">
            View Account
          </cr-button>
          <cr-button hidden$="[[!showActivate_(networkState)]]"
              on-click="onActivateClicked_">
            Activate
          </cr-button>
          <cr-button hidden$="[[!showConnect_(networkState)]]"
              disabled="[[!enableConnect_(networkState)]]"
              on-click="onConnectClicked_">
            Connect
          </cr-button>
          <cr-button hidden$="[[!showDisconnect_(networkState)]]"
              on-click="onDisconnectClicked_">
            Disconnect
          </cr-button>
        </div>

        <!-- Advanced section -->
        <div id="advancedDiv" class="layout vertical"
            hidden$="[[!hasAdvancedOrDeviceFields_(networkState)]]">
          <cr-collapse opened="[[advancedExpanded]]">
            <!-- Advanced properties -->
            <div id="advancedInfoDiv" class="layout vertical">
              <network-property-list
                  fields="[[getAdvancedFields_(networkState)]]"
                  network-state="[[networkState]]">
              </network-property-list>
            </div>

            <!-- Network (APN, address, nameservers) -->
            <div id="addressDiv" class="layout vertical"
                hidden$="[[!hasNetworkSection_(networkState)]]">
              <cr-button toggles active="{{addressExpanded}}">
                Network
              </cr-button>
              <cr-collapse opened="[[addressExpanded]]">
                <div class="layout vertical flex">
                  <network-apnlist editable
                      hidden$="[[!isType_(networkState, NetworkType.CELLULAR)]]"
                      network-state="[[networkState]]"
                      apnlist="[[networkState.Cellular.APNList]]"
                      on-apn-change="onNetworkPropertyChange_">
                  </network-apnlist>
                  <network-ip-config editable
                      network-state="[[networkState]]"
                      on-ip-change="onIPConfigChange_">
                  </network-ip-config>
                  <network-nameservers editable
                      network-state="[[networkState]]"
                      on-nameservers-change="onIPConfigChange_">
                  </network-nameservers>
                </div>
              </cr-collapse>
            </div>

            <!-- Proxy -->
            <div class="layout vertical"
                hidden$="[[!hasNetworkSection_(networkState)]]">
              <cr-button toggles active="{{proxyExpanded}}">
                Proxy
              </cr-button>
              <cr-collapse opened="[[proxyExpanded]]">
                <div id="proxyDiv" class="layout vertical flex">
                  <network-proxy editable
                      network-state="[[networkState]]"
                      on-proxy-change="onProxyChange_">
                  </network-proxy>
                </div>
              </cr-collapse>
            </div>

            <!-- Device properties -->
            <div class="layout vertical"
                hidden$="[[!hasDeviceFields_(networkState)]]">
              <cr-button toggles active="{{deviceExpanded}}">
                Device
              </cr-button>
              <cr-collapse opened="[[deviceExpanded]]">
                <network-property-list
                    fields="[[getDeviceFields_(networkState)]]"
                    network-state="[[networkState]]">
                </network-property-list>
                <!-- TODO(stevenjb): Cellular SIM -->
              </cr-collapse>
            </div>
          </cr-collapse>
        </div>
      </div>
    </div>
  </template>
  <script src="internet_detail_page.js"></script>
</dom-module>
